import { ref } from 'vue';
import myAxios from '@/api/myAxios';
import { type UploadFile, type UploadProps, genFileId, type UploadRawFile, type FormInstance, type FormRules } from 'element-plus';
import { WarnInfo } from '../messageInfo';

export const productImgMap = new Map() //商品图片数组  
export const productImgArr: any = ref([])
export const fileSimple = ref() //单个文件
export const form : any = ref({   //添加实体类商品的表单
    name: '',   //商品名称
    price: '',  //商品价格
    intro: '',//产品简介
    festivalName: '', //节日名称
    type: '',//类别
    label: '',//商品标签
    introDetail: '',//详情描述
    goodImg: '',  //商品图片url
    detailImg: '',  //图文详情url
    inventory: '' //库存
})

//图片上传请求  此请求只要选择了图片，就会默认上传
export const handleChange = async (file: any, flag: number) => { //12.18改
    fileSimple.value = file
    let formData = new FormData()  //这一步很重要 创建一个FormData对象
    formData.append("file", fileSimple.value.raw)  //fileSimple.value.raw 才是文件主体  将其以文件的格式插入formData
    const res = await myAxios({   //编写请求，与以前的请求不同，这一次要指定好头部类型和文件类型
        url: '/file/upload/server/not_login',
        method: 'post',
        headers: {
            'content-Type': 'multipart/form-data'
        },
        data: {
            biz: "test",
            // 取出formData对象中的file
            file: formData.get("file")
        }
    })
    if (res.data.code === 1) {
        if (flag === 0) {
            productImgArr.value.splice(0, productImgArr.value.length)  //一并删除数组中存放的图片Url地址
            productImgMap.set(fileSimple.value.uid, res.data.data)
            productImgMap.forEach(loopMap)   //将图片url插入到数组中
            form.value.goodImg = formatString()
        } else {
            form.value.detailImg = res.data.data
        }
    }
}

const formatString = () => {  //拼接图片URL,方便传给后端
    var str = ''
    str = productImgArr.value.join(';')
    return str
}

const loopMap = (value: any, key: any, map: any) => {  //循环商品图片Map集合函数,用于给请求的字段赋值
    productImgArr.value.push(value)
}

export const handleRemove: UploadProps['onRemove'] = (uploadFile, uploadFiles) => {    //uploadFile表示当前删除的图片，uploadFiles是还剩余的图片信息
    productImgMap.delete(uploadFile.uid)
    productImgArr.value.splice(0, productImgArr.value.length)  //一并删除数组中存放的图片Url地址
    productImgMap.forEach(loopMap)
    form.value.goodImg = formatString()
}

export const Exceed_ProductImg: UploadProps['onExceed'] = (files) => { //覆盖商品照片   'onExceed'当文件个数超过限制时，做出的判断
    WarnInfo('最多只能上传七张图片!')
}